## ubuntu-push 0.2%2B14.04.20140411

=== http13client/Makefile ===
# help massage and extract from go development 1.3 net/http the client bits

grab:
	cp $(GOCHECKOUT)/src/pkg/net/http/*.go .
	cp $(GOCHECKOUT)/LICENSE .
	mkdir -p httptest
	mkdir -p httputil
	mkdir -p testdata
	cp $(GOCHECKOUT)/src/pkg/net/http/httptest/*.go httptest
	cp $(GOCHECKOUT)/src/pkg/net//http/httputil/*.go httputil
	cp $(GOCHECKOUT)/src/pkg/net/http/testdata/* testdata
	hg -R $(GOCHECKOUT) summary > _using.txt

full-prepare:
	patch -R -p5 < _patches/sync_pool.Rpatch
	patch -p1 < _patches/no_keepalive.patch
	sed -i -e 's+"net/http"+"launchpad.net/ubuntu-push/http13client"+' *.go httptest/*.go httputil/*.go
	sed -i -e 's+"net/http/+"launchpad.net/ubuntu-push/http13client/+' *.go httptest/*.go httputil/*.go
	patch -p1 < _patches/no_serve_test_unsupported_bench.patch

prune:
	rm -rf example_test.go filetransport*.go fs*.go race.go range_test.go \
	sniff*.go httptest httputil testdata triv.go jar.go status.go
	sed -i -e 's+"launchpad.net/ubuntu-push/http13client/+"net/http/+' *.go

fix:
	patch -p1 < _patches/empty_server.patch
	patch -p1 < _patches/fix_tests.patch
	patch -p1 < _patches/fix_code.patch
	patch -p1 < _patches/fix_status.patch
	patch -p1 < _patches/tweak_doc_go.patch
	go fmt

wipe:
	rm -rf *.go httptest httputil testdata

.PHONY: grab full-prepare prune fix wipe

## ubuntu-push 0.2+14.04.20140411

=== Makefile ===
GOPATH := $(shell cd ../../..; pwd)
export GOPATH

PROJECT = launchpad.net/ubuntu-push

ifneq ($(CURDIR),$(GOPATH)/src/launchpad.net/ubuntu-push)
$(error unexpected curdir and/or layout)
endif

GODEPS = launchpad.net/gocheck
GODEPS += launchpad.net/go-dbus/v1
GODEPS += launchpad.net/go-xdg/v0
GODEPS += code.google.com/p/gosqlite/sqlite3

TOTEST = $(shell env GOPATH=$(GOPATH) go list $(PROJECT)/...|grep -v acceptance|grep -v http13client )

bootstrap:
	mkdir -p $(GOPATH)/bin
	mkdir -p $(GOPATH)/pkg
	go get -u launchpad.net/godeps
	go get -d -u $(GODEPS)
	$(GOPATH)/bin/godeps -u dependencies.tsv
	go install $(GODEPS)

check:
	go test $(TESTFLAGS) $(TOTEST)

check-race:
	go test $(TESTFLAGS) -race $(TOTEST)

acceptance:
	cd server/acceptance; ./acceptance.sh

build-client:
	go build ubuntu-push-client.go

build-server-dev:
	go build -o push-server-dev launchpad.net/ubuntu-push/server/dev

run-server-dev:
	go run server/dev/*.go sampleconfigs/dev.json

coverage-summary:
	go test $(TESTFLAGS) -a -cover $(TOTEST)

coverage-html:
	mkdir -p coverhtml
	for pkg in $(TOTEST); do \
		relname="$${pkg#$(PROJECT)/}" ; \
		mkdir -p coverhtml/$$(dirname $${relname}) ; \
		go test $(TESTFLAGS) -a -coverprofile=coverhtml/$${relname}.out $$pkg ; \
		if [ -f coverhtml/$${relname}.out ] ; then \
	           go tool cover -html=coverhtml/$${relname}.out -o coverhtml/$${relname}.html ; \
	           go tool cover -func=coverhtml/$${relname}.out -o coverhtml/$${relname}.txt ; \
		fi \
	done

format:
	go fmt $(PROJECT)/...

check-format:
	scripts/check_fmt $(PROJECT)

protocol-diagrams: protocol/state-diag-client.svg protocol/state-diag-session.svg
%.svg: %.gv
	# requires graphviz installed
	dot -Tsvg $< > $@

.PHONY: bootstrap check check-race format check-format \
	acceptance build-client build server-dev run-server-dev \
	coverage-summary coverage-html protocol-diagrams

=== debian/changelog ===
ubuntu-push (0.2+14.04.20140411-0ubuntu1) trusty; urgency=medium

  [ John Lenton ]
  * New upstream release.

  [ Richard Huddie ]
  * added basic autopilot framework
  * configparser and http post updates
  * removed tests folder

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 11 Apr 2014 18:31:57 +0000

ubuntu-push (0.1+14.04.20140404-0ubuntu1) trusty; urgency=low

  [ Tarmac ]
  * Merge automatic into trunk.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 04 Apr 2014 14:52:06 +0000

ubuntu-push (0.1+14.04.20140327-0ubuntu1) trusty; urgency=medium

  [ John Lenton ]
  * got rid of multiarch bug

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 27 Mar 2014 14:11:31 +0000

ubuntu-push (0.1+14.04.20140325.2-0ubuntu1) trusty; urgency=low

  [ Diogo Baeder de Paula Pinto ]
  * [r=pedronis] Adding authorization field to the ConnectMsg struct

  [ Robert Bruce Park ]
  * [r=chipaca] Minor cleanup, with wrap-and-sort.

  [ Nicola Larosa ]
  * [r=pedronis] Reflow comments so that subsequent changes are more
    readable. Only comment reflows, no other changes.
  * [r=pedronis] Clean up docs and comments, and make them look better
    in go doc. No behavior change at all.

  [ john.lenton@canonical.com ]
  * [r=pedronis] A thin wrapper around libwhoopsie/identifier.h.
  * [r=pedronis] A simplified (and more testable) dbus api
  * [r=pedronis] A simplified, testable, Network Manager wrapper
  * [r=pedronis] A super simple connectivity api (in the "am i
    connected?" sense)
  * [r=pedronis] Switched networkmanager to use the non-deprecated api
    for state.
  * [r=pedronis] moved the object proxy into the endpoint
  * [r=pedronis] Made the bus support multi-valued signals (preparatory
    for notifications). Also added tests for TestingBus.
  * [r=pedronis] notifications! first, a low-level api.
  * [r=pedronis] URLDispatcher (and extended endpoint.Call to return
    []interface{})
  * [r=pedronis] moved a bunch of packages under bus/
  * [r=pedronis] change a few of the bus/* services to take a
    bus.Endpoint instead of a bus.Bus
  * [r=pedronis] reworked bus.Endpoint to have a Dial() method, added an
    AutoRedialer() and put the redialing logic in there (for use on
    sessionbus as well, later).
  * [r=pedronis] Nuked the connectivity example.
  * [r=pedronis] Renamed bus/connectivity's Config to
    ConnectivityConfig.
  * [r=pedronis] Introducing AutoRetry, a generic AutoRetry.
  * [r=pedronis] Made bus.Endpoint's WatchSignal use an (exported)
    channel for waiting between sending values, if the channel is not
    nil.
  * [r=pedronis] The client session level map. Interesting as an
    interface and not much more, right now.
  * [r=pedronis] A wild client session appears!
  * [r=pedronis] get rid of a race in the bus/testing watchticker thing
  * [r=pedronis] The handling of the ping.
  * [r=pedronis,chipaca] Broadcasting your horizons.
  * [r=pedronis] The running man.
  * [r=pedronis] Starting to take shape.
  * [r=pedronis] Killed checkRunnable; renamed: Dial -> connect, run ->
    loop.
  * [r=pedronis] Ladies and gentlemen, the client session.
  * [r=pedronis] first step of the v0 of the client
  * [r=pedronis] second step of the v0 of the client: getting the device
    id
  * [r=pedronis] part 3: setting up the bus
  * [r=pedronis] Part 4: added State to client/session, to aid in
    testing some aspects of this.
  * [r=pedronis] added handleConnState
  * [r=pedronis] Several things: features:. * bus/testing/'s Endpoint
    now tracks Calls; call bus/testing.GetCallCargs(endp) to get the
    list. * Client.handleErr, Client.handleNotification and
    Client.handleClick (and tests) cleanups:. * renamed client's
    Client's connState to hasConnectivity * split out code from
    handleConnState into initSession/connectSession/disconnectSession
  * [r=pedronis] Several things: features:. * Client.doLoop, the puppet
    master. fixes and cleanups:. * added log_level to client config *
    added the mysterious sessionRetryCh, used in doLoop to avoid a
    rather common starvation scenario. * found a way not to panic out in
    initSession (not that it's much better) * unified logging in the
    client tests a bit * added logging to session's start error states.
  * [r=pedronis] Reworked or refactored util/redialer, and a bit of
    client/session, and client.
  * [r=pedronis] TestLogger
  * [r=pedronis] and this completes the client library (for now)
  * [r=pedronis] made GetSourceRelative look at the environ to help make
    the tests pass in packaging
  * [r=pedronis] Gave client a constructor, moved setting config file to
    there.
  * [r=pedronis] change the levelmap interface to return errors
  * [r=pedronis] this is sqlevelmap
  * [r=pedronis] bring sqlevelmap into session
  * [r=pedronis] and this gives the client the ability to persist its
    session's levelmap
  * [r=pedronis] The Push Client itself.
  * [r=diogobaeder] Merging the packaging branch (to get on the CI
    train).
  * [r=didrocks] Fixes to packaging, as suggested by didrocks.
  * Bring back source/format, so executable .install file works.

  [ Timo Jyrinki ]
  * [r=chipaca] Add http13client copyright information and use GPL-3.0
    (non-+) license consistently.

  [ Ubuntu daily release ]
  * New rebuild forced

  [ Samuele Pedroni (Canonical Services Ltd.) ]
  * [r=chipaca] and as a start we get some protocol support and a
    development server and infrastructure
  * [r=chipaca] couple of extra tests and changes to improve test
    coverage
  * [r=chipaca] -insecure (don't check certs) -reportPings=f (don't
    report pings) flags for acceptanceclient
  * [r=chipaca] make the tracker used by the session for logging
    pluggable
  * [r=chipaca] introduce CONNACK message from the server after CONNECT
    to inform the client of connection params like ping interval
  * [r=chipaca] protocol diagrams using graphviz


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_GOPKG := launchpad.net/ubuntu-push
export DEB_BUILD_OPTIONS := nostrip
export UBUNTU_PUSH_TEST_RESOURCES_ROOT := $(CURDIR)

override_dh_install:
	dh_install -Xusr/bin/cmd -Xusr/bin/dev --fail-missing

%:
	dh $@ --buildsystem=golang --with=golang

## ubuntu-push 0.2.1%2B14.04.20140423.1

=== debian/control ===
Source: ubuntu-push
Section: net
Priority: optional
X-Original-Maintainer: John Lenton <john.lenton@canonical.com>
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 9),
               dh-exec (>= 0.3),
               dh-golang,
               golang-go,
               golang-go-dbus-dev,
               golang-go-xdg-dev,
               golang-gocheck-dev,
               golang-gosqlite-dev,
               libgcrypt11-dev,
               libglib2.0-dev (>= 2.31.6),
               libwhoopsie-dev,
Standards-Version: 3.9.5
Homepage: http://launchpad.net/ubuntu-push
Vcs-Bzr: lp:ubuntu-push
Vcs-Browser: http://bazaar.launchpad.net/~ubuntu-push-hackers/ubuntu-push/trunk/files

Package: ubuntu-push-client
Architecture: any
Multi-Arch: foreign
Depends: dbus,
         network-manager,
         qtdeclarative5-unity-notifications-plugin | notification-daemon,
         url-dispatcher,
         ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using}
Description: Ubuntu Push Notifications client-side daemon
 The Ubuntu Push Notifications client-side daemon.

Package: golang-ubuntu-push-dev
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using}
Description: Ubuntu Push Notifications client-side daemon development package
 The Ubuntu Push Notifications client-side daemon library.
 .
 This package contains the source.

## ubuntu-push 0.2.1+14.04.20140423.1

=== debian/changelog ===
ubuntu-push (0.2.1+14.04.20140423.1-0ubuntu1) trusty; urgency=high

  [ Samuele Pedroni ]
  * gave the client the ability to get config from commandline
    ( => easier automated testing) (LP: #1311600)

  [ John Lenton ]
  * Ensure ubuntu-push-client is the only one running in the session.
    (LP: #1309432)
  * Remove supurious numbers in brackets in notifications. (LP: #1308145)
  * Check the server certificate and server name. (LP: #1297969)
  * Loop whoopsie_identifier_generate until it starts working. (LP: #1309237)
  * In the session: set a flag on connect, clear it on successfully
    replying to ping or broadcast messages, check it at the top of
    autoredial. Also track the last autoredial, and set the delay flag if
    autoredial is re-called too quickly. (LP: #1309231)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 23 Apr 2014 11:54:00 +0000

## ubuntu-push 0.64.1+14.10.20140910

=== debian/changelog ===
ubuntu-push (0.64.1+14.10.20140910-0ubuntu1) utopic; urgency=medium

  [ Roberto Alsina ]
  * Don't show popups if the screen is locked.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 10 Sep 2014 18:03:25 +0000

ubuntu-push (0.64+14.10.20140908-0ubuntu1) utopic; urgency=medium

  [ Roberto Alsina ]
  * Remove tokens from debug output
  * Doc updates
  * Included example code in docs directory

  [ John R. Lenton]
  * Use libaccounts to track changes to the u1 account used for auth; restart the session on change.
  * Set the MEDIA_PROP env var to select the right media role for notification sounds

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 08 Sep 2014 18:05:11 +0000

ubuntu-push (0.63.2+14.10.20140902.1-0ubuntu1) utopic; urgency=medium

  [ Roberto Alsina ]
  * Avoid busy-loop wben powerd doesn't respond.

  [ Guillermo Gonzalez ]
  * Replace DBus url-dispatcher API with liburl-dispatcher1 C API.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 02 Sep 2014 17:28:19 +0000

ubuntu-push (0.63.1+14.10.20140828-0ubuntu1) utopic; urgency=medium

  [ Samuele Pedroni ]
  * Support taking a cookie from the server and sending it back on connect (feature was incomplete).

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Thu, 28 Aug 2014 19:15:56 +0000

ubuntu-push (0.63+14.10.20140827-0ubuntu1) utopic; urgency=medium

  [ Samuele Pedroni ]
  * Support taking a cookie from the server and sending it back on connect.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 27 Aug 2014 18:47:25 +0000

ubuntu-push (0.62+14.10.20140825.1-0ubuntu1) utopic; urgency=medium

  [ Samuele Pedroni ]
  * Avoid rare race in kindpool_test.go

  [ John R. Lenton]
  * Interface with account-polld's dbus api.
  * Powerd integration.
  * Use symbolic icon for secondary icon in notification.

  [Roberto Alsina]
  * Log legacy helper failures.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 25 Aug 2014 16:40:29 +0000

ubuntu-push (0.61+14.10.20140812.4-0ubuntu1) utopic; urgency=medium

  [ Guillermo Gonzalez ]
  * Update autopilot tests to work with 0.50, fix setup.sh issues and add new tests for the broadcast notification changes.
  * Replace whoopsie with /var/lib/dbus/machine-id to get the device ID.

  [ John R. Lenton]
  * Support simpler sounds API.
  * Support simpler vibrations API.
  * Remove Vibration's confusing and redundant Duration attribute.
  * Change PostalService's New() to take a setup object.
  * goctest.
  * Make messaging menu entries show current time instead of epoch for timestamp of 0.
  * Tweak the upstart script, start after unity.
  * Correctly report invalid app ids, missing apps, and package/app id mismatches as separate errors over dbus.

  [Roberto Alsina]
  * Check that sound paths don't go up into the tree.
  * Initial draft of QML-based doc

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 12 Aug 2014 02:33:16 +0000

ubuntu-push (0.60+14.10.20140804-0ubuntu1) utopic; urgency=medium

  [ Guillermo Gonzalez ]
  * Add click hook to collect helpers data on install/update/etc and
    support to read the helper cached data, when available, and only
    refresh it when it changes.
  * Include notification settings cleanup in the click install hook, and
    rename it to click-hook

  [ John R. Lenton ]
  * For the gsettings interface: Improve, add tests, make design-compliant.

  [Roberto Alsina]
  * Query gsettings as to whether a notification should be presented.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 04 Aug 2014 15:38:34 +0000

ubuntu-push (0.50+14.10.20140801-0ubuntu1) utopic; urgency=low

  * New rebuild forced

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Fri, 01 Aug 2014 02:15:29 +0000

ubuntu-push (0.50+14.10.20140729-0ubuntu1) utopic; urgency=medium

  [ Samuele Pedroni ]
  * Cleanup and improve post/Post tests

  [ Guillermo Gonzalez ]
  * Add a loop to cleanup MessagingMenu.notifications map when the
    notifications are dismissed.
  * Add TestURL to URLDispatcher and update DispatchURL signature.
  * Add validateActions (check with url-dispatcher->TestURL) method to the
    PostalService and wire it in messageHandler.

  [ John R. Lenton ]
  * Implement ListPersistent/ClearPersistent/SetCounter postal endpoints.
  * Remove snap decisions support.
  * Remove the notification from the messaging menu when the bubble is
    acted on.
  * Don't run more than 5 helpers at a time, and never more than one per app.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 29 Jul 2014 16:57:35 +0000

ubuntu-push (0.49.1+14.10.20140723.1-0ubuntu1) utopic; urgency=medium

  [ John R. Lenton ]
  * Fixed push-helper click hook pointing at the wrong place.
  * Made exec-tool executable.

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Wed, 23 Jul 2014 14:09:31 +0000

ubuntu-push (0.49+14.10.20140721.2-0ubuntu1) utopic; urgency=medium

  [Samuele Pedroni]
  * Check in the api whether an app has pushed too many notifications.
  * Return payload of most recent notification in too many pending
    notifications API error.
  * Introduce clear_pending flag to clean everything pending for an app.
  * Refactor and cleanup.
  * Introduce replace_tag support in store and api, with acceptance test.
  * Teach a couple of trick to cmd/acceptanceclient: exit on run timeout,
    wait for event matching given regexp pattern.
  * Limit unicast data payload to 2K.
  * Payload should be json (fixes message needing to be base64-encoded in
    helper reply)
  * Implement limited mboxes
  * Refactor and cleanup of things done in haste by Chipaca.

  [Richard Huddie]
  * autopilot test framework and basic coverage of broadcast notifications.

  [Guillermo Gonzalez]
  * Add scripts to simplify setup/run of the autopilot tests in the
    device/emulator and include basic unicast tests.
  * Add autopilot test for notification using the emblem counter.


## ubuntu-push 0.68%2B16.04.20160310.2

=== debian/changelog ===
ubuntu-push (0.68+16.04.20160310.2-0ubuntu1) xenial; urgency=medium

  [ jonas-drange ]
  * deprecate the usage of Info in the systemimage module and replace it
    with Information disable runtime cgo pointer checks (LP: #1517189,
    #1469398)

 -- Barry Warsaw <ci-train-bot@canonical.com>  Thu, 10 Mar 2016 21:35:55 +0000

ubuntu-push (0.68+16.04.20160114-0ubuntu1) xenial; urgency=medium

  * Handle gccgo on s390x. (LP: #1517189, #1469398)

 -- Rodney Dawes <ci-train-bot@canonical.com>  Thu, 14 Jan 2016 21:13:22 +0000

ubuntu-push (0.68+16.04.20151210-0ubuntu1) xenial; urgency=medium

  [ jonas-drange ]
  * use Notifications dbus API to play sounds (LP: #1517189, #1469398)

 -- Jonas G. Drange <ci-train-bot@canonical.com>  Thu, 10 Dec 2015 10:16:28 +0000

ubuntu-push (0.68+16.04.20151203-0ubuntu1) xenial; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ jonas-drange ]
  * present a notification even though the screen is locked (LP:
    #1517189, #1469398)

 -- Jonas G. Drange <ci-train-bot@canonical.com>  Thu, 03 Dec 2015 14:56:24 +0000

ubuntu-push (0.68+16.04.20151130-0ubuntu1) xenial; urgency=medium

  [ CI Train Bot ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)
  * New rebuild forced.

  [ John R. Lenton ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

  [ Michael Hudson-Doyle ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

  [ Rodney Dawes ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

  [ Samuele Pedroni (Canonical Services Ltd.) ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

  [ jonas-drange ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

 -- Timo Jyrinki <timo.jyrinki@canonical.com>  Mon, 30 Nov 2015 21:16:20 +0000

ubuntu-push (0.68+15.10.20150814.1-0ubuntu1) wily; urgency=medium

  [ CI Train Bot ]
  * New rebuild forced.

  [ Samuele Pedroni (Canonical Services Ltd.) ]
  * address lp:1451510 aggressively finding gone notifications in Tags()
    truncate runtime.Stack result to size, otherwise we log \x00s or old
    stuff (LP: #1451510)

 -- CI Train Bot <ci-train-bot@canonical.com>  Fri, 14 Aug 2015 14:05:16 +0000

ubuntu-push (0.68+15.04.20150430.1-0ubuntu2~ppa1) wily; urgency=medium

  [ John R. Lenton ]
  * go's compatibility promise fails us again; fixes for 1.4.

 -- John R. Lenton <john.lenton@canonical.com>  Fri, 31 Jul 2015 13:52:04 +0100

ubuntu-push (0.68+15.04.20150430.1-0ubuntu2~gcc5.1) wily; urgency=medium

  * No-change test rebuild for g++5 ABI transition

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 15 Jul 2015 16:10:40 +0000

ubuntu-push (0.68+15.04.20150430.1-0ubuntu1) vivid; urgency=medium

  [ Samuele Pedroni ]
  * switch poller to use killswitch state for WLAN instead of
    misleading NM property (LP: #1446584)
  * don't have goroutines from a previous test overlap with the next,
    races gets detected otherwise
  * have the TestDialWorksDirect* tests quickly timeout, go1.3 wants a
    ServerName set in the tls config for them to work
  * fix flaky test
  * support sha384/512 certs, some exercizing of that
  * let send a build number with acceptanceclient
  * add helper to get int out of ConnectMsg Info

  [ CI Train Bot ]
  * New rebuild forced.

 -- CI Train Bot <ci-train-bot@canonical.com>  Thu, 30 Apr 2015 15:08:57 +0000

ubuntu-push (0.68+15.04.20150403-0ubuntu1) vivid; urgency=medium

  [ Samuele Pedroni ]
  [Roberto Alsina]
  * click-hook: report failure if hooks_path doesn't exist. [client]

  [Bret Barker]
  * add a hacky busy sleep loop to workaround go's sleep not
    accounting for suspended time, more logging (lp:1435109). [client]

  [John R. Lenton]
  * Refactor code maintaining session (better fix for lp:1390663) [client]

  [Samuele Pedroni]
  * just delegate whether there's a update-worthy image to the
    system-settings helper and system-image. [client]
  * stop waking up for polling if in flight-mode and wireless not


## ubuntu-push 0.68+15.04.20150306.2

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_GOPKG := launchpad.net/ubuntu-push
export UBUNTU_PUSH_TEST_RESOURCES_ROOT := $(CURDIR)

override_dh_auto_build:
	dh_auto_build --buildsystem=golang
	(cd signing-helper && cmake . && make)

# overriding dh_auto_test because the http13client tests don't all pass on go < 1.3
# (should go away once we ship go 1.3)
override_dh_auto_test:
	cd $$( find ./ -type d -regex '\./[^/]*/src/launchpad.net' -printf "%h\n" | head -n1) && \
	env GOPATH=$$(cd ..; pwd) go test -v $$(env GOPATH=$$(cd ..; pwd) go list $(DH_GOPKG)/... | grep -v acceptance | grep -v http13client )

override_dh_install:
	dh_install -Xusr/bin/cmd --fail-missing

%:
	dh $@ --buildsystem=golang --with=golang

## ubuntu-push 0.68+15.04.20150430.1

=== signing-helper/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
SET (EXAMPLES_TARGET ubuntuoneauth-examples)

SET (SIGNING_EXE "signing-helper")

find_package (PkgConfig REQUIRED)
pkg_check_modules(UBUNTUONE REQUIRED ubuntuoneauth-2.0)
add_definitions(${UBUNTUONE_CFLAGS} ${UBUNTUONE_CFLAGS_OTHER})


# Qt5 bits
SET (CMAKE_INCLUDE_CURRENT_DIR ON)
SET (CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

FILE (GLOB SIGNING_SOURCES signing*.cpp)
FILE (GLOB SIGNING_HEADERS signing*.h)

add_executable (${SIGNING_EXE}
  ${SIGNING_SOURCES}
  ${SIGNING_HEADERS})
qt5_use_modules (${SIGNING_EXE} DBus Network)

target_link_libraries (${SIGNING_EXE}
  ${UBUNTUONE_LDFLAGS})



add_custom_target(examples-valgrind
    COMMAND "valgrind --tool=memcheck ${CMAKE_CURRENT_BINARY_DIR}/${SIGNING_EXE}"
    DEPENDS ${SIGNING_EXE}
)

add_custom_target(examples-valgrind-leaks
    COMMAND "valgrind --tool=memcheck --track-origins=yes --num-callers=40 --leak-resolution=high --leak-check=full ${CMAKE_CURRENT_BINARY_DIR}/${SIGNING_EXE}"
    DEPENDS ${SIGNING_EXE}
)

INSTALL_TARGETS( "lib/ubuntu-push-client/" ${SIGNING_EXE})

## ubuntu-push 0.68+16.04.20151124

=== debian/changelog ===
ubuntu-push (0.68+16.04.20151124-0ubuntu1) xenial; urgency=medium

  [ CI Train Bot ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)
  * New rebuild forced.

  [ John R. Lenton ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

  [ Michael Hudson-Doyle ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

  [ Rodney Dawes ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

  [ Samuele Pedroni (Canonical Services Ltd.) ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

  [ jonas-drange ]
  * Add support for signing methods other than POST via argv[2]. Test
    fixes for Go 1.5. Avoid losing notifications when screen is locked.
    Fix lp:1469398 by using the connectivity state. Fix case where a
    failed powerd wakeup request would deadlock step(). Assert whether
    or not there's a connection using the same method as local
    connectivity package. (LP: #1517189, #1469398)

 -- Timo Jyrinki <timo.jyrinki@canonical.com>  Tue, 24 Nov 2015 11:22:21 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: ubuntu-push
 Section: net
 Priority: optional
-X-Original-Maintainer: John Lenton <john.lenton@canonical.com>
+XSBC-Original-Maintainer: John Lenton <john.lenton@canonical.com>
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: debhelper (>= 9),
                dh-exec (>= 0.3),
@@ -11,9 +11,19 @@
                golang-go-xdg-dev,
                golang-gocheck-dev,
                golang-gosqlite-dev,
+               golang-uuid-dev,
                libgcrypt11-dev,
                libglib2.0-dev (>= 2.31.6),
-               libwhoopsie-dev,
+               libmessaging-menu-dev,
+               libubuntu-app-launch2-dev,
+               libubuntuoneauth-2.0-dev,
+               libdbus-1-dev,
+               libnih-dbus-dev,
+               libclick-0.4-dev,
+               liburl-dispatcher1-dev,
+               libaccounts-glib-dev,
+               cmake,
+               python3,
 Standards-Version: 3.9.5
 Homepage: http://launchpad.net/ubuntu-push
 Vcs-Bzr: lp:ubuntu-push
@@ -41,3 +51,23 @@
  The Ubuntu Push Notifications client-side daemon library.
  .
  This package contains the source.
+
+Package: ubuntu-push-dev-server
+Architecture: any
+Multi-Arch: foreign
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Built-Using: ${misc:Built-Using}
+Description: Ubuntu Push Notifications development & testing server
+ The Ubuntu Push Notifications dev & testing server.
+
+Package: ubuntu-push-autopilot
+Architecture: any
+Multi-Arch: foreign
+Depends: unity8-autopilot,
+         unity-scope-click,
+         ubuntu-push-client,
+Recommends: ubuntu-push-dev-server,
+Built-Using: ${misc:Built-Using}
+Description: Ubuntu Push Notifications autopilot tests
+ The Ubuntu Push Notifications autopilot tests.

## ubuntu-push 0.68+16.04.20151130

=== Makefile ===
GOPATH := $(shell cd ../../..; pwd)
export GOPATH

PROJECT = launchpad.net/ubuntu-push

ifneq ($(CURDIR),$(GOPATH)/src/launchpad.net/ubuntu-push)
$(error unexpected curdir and/or layout)
endif

GODEPS = launchpad.net/gocheck
GODEPS += launchpad.net/go-dbus/v1
GODEPS += launchpad.net/go-xdg/v0
GODEPS += code.google.com/p/gosqlite/sqlite3
GODEPS += code.google.com/p/go-uuid/uuid

GOTEST := ./scripts/goctest

TOTEST = $(shell env GOPATH=$(GOPATH) go list $(PROJECT)/...|grep -v acceptance|grep -v http13client )
TOBUILD = $(shell grep -lr '^package main')

all: fetchdeps bootstrap build-client build-server-dev

fetchdeps: .has-fetched-deps

.has-fetched-deps: PACKAGE_DEPS
	@$(MAKE) --no-print-directory refetchdeps
	@touch $@

refetchdeps:
	sudo apt-get install $$( grep -v '^#' PACKAGE_DEPS )

bootstrap: dependencies.tsv
	$(RM) -r $(GOPATH)/pkg
	mkdir -p $(GOPATH)/bin
	mkdir -p $(GOPATH)/pkg
	go get -u launchpad.net/godeps
	go get -d -u $(GODEPS)
	$(GOPATH)/bin/godeps -u dependencies.tsv
	go install $(GODEPS)

dependencies.tsv:
	$(GOPATH)/bin/godeps -t $(TOTEST) $(foreach i,$(TOBUILD),$(dir $(PROJECT)/$(i))) 2>/dev/null | cat > $@

check:
	$(GOTEST) $(TESTFLAGS) $(TOTEST)

check-race:
	$(GOTEST) $(TESTFLAGS) -race $(TOTEST)

acceptance:
	cd server/acceptance; ./acceptance.sh

build-client: ubuntu-push-client signing-helper/signing-helper

%.deps: %
	$(SH) scripts/deps.sh $<

%: %.go
	go build -o $@ $<

include $(TOBUILD:.go=.go.deps)

signing-helper/Makefile: signing-helper/CMakeLists.txt signing-helper/signing-helper.cpp signing-helper/signing.h
	cd signing-helper && (make clean || true) && cmake .

signing-helper/signing-helper: signing-helper/Makefile signing-helper/signing-helper.cpp signing-helper/signing.h
	cd signing-helper && make

build-server-dev: push-server-dev

run-server-dev: push-server-dev
	./$< sampleconfigs/dev.json

push-server-dev: server/dev/server
	mv $< $@

# very basic cleanup stuff; needs more work
clean:
	$(RM) -r coverhtml
	$(MAKE) -C signing-helper clean || true
	$(RM) push-server-dev
	$(RM) $(TOBUILD:.go=)

distclean:
	bzr clean-tree --verbose --ignored --force

coverage-summary:
	$(GOTEST) $(TESTFLAGS) -a -cover $(TOTEST)

coverage-html:
	mkdir -p coverhtml
	for pkg in $(TOTEST); do \
		relname="$${pkg#$(PROJECT)/}" ; \
		mkdir -p coverhtml/$$(dirname $${relname}) ; \
		$(GOTEST) $(TESTFLAGS) -a -coverprofile=coverhtml/$${relname}.out $$pkg ; \
		if [ -f coverhtml/$${relname}.out ] ; then \
	           go tool cover -html=coverhtml/$${relname}.out -o coverhtml/$${relname}.html ; \
	           go tool cover -func=coverhtml/$${relname}.out -o coverhtml/$${relname}.txt ; \
		fi \
	done

format:
	go fmt $(PROJECT)/...

check-format:
	scripts/check_fmt $(PROJECT)

protocol-diagrams: protocol/state-diag-client.svg protocol/state-diag-session.svg
%.svg: %.gv
	# requires graphviz installed
	dot -Tsvg $< > $@

.PHONY: bootstrap check check-race format check-format \
	acceptance build-client build-server-dev run-server-dev \
	coverage-summary coverage-html protocol-diagrams \
	fetchdeps refetchdeps clean distclean all

.INTERMEDIATE: server/dev/server

## ubuntu-push 0.68+16.04.20151210

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_GOPKG := launchpad.net/ubuntu-push
export UBUNTU_PUSH_TEST_RESOURCES_ROOT := $(CURDIR)

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifneq (,$(filter $(DEB_HOST_ARCH), arm64 powerpc ppc64el))
  pkg_configs = ubuntuoneauth-2.0 libaccounts-glib click-0.4 ubuntu-app-launch-2 url-dispatcher-1 messaging-menu dbus-1 libnih libnih-dbus glib-2.0 gobject-2.0
  export CGO_CFLAGS := \
    $(shell $(foreach pkg, $(pkg_configs), pkg-config --cflags $(pkg); ))
  export CGO_CXXFLAGS := $(CGO_CFLAGS)
  export CGO_LDFLAGS := \
    $(shell $(foreach pkg, $(pkg_configs), pkg-config --libs $(pkg); ))
  $(warning setting CGO_CFLAGS   = $(CGO_CFLAGS))
  $(warning setting CGO_CXXFLAGS = $(CGO_CXXFLAGS))
  $(warning setting CGO_LDFLAGS  = $(CGO_LDFLAGS))

  # some tests seem to hang
  DEB_BUILD_OPTIONS := nocheck $(DEB_BUILD_OPTIONS)
endif

override_dh_auto_build:
	dh_auto_build --buildsystem=golang
	(cd signing-helper && cmake . && make)

override_dh_install:
	dh_install -Xusr/bin/cmd --fail-missing

%:
	dh $@ --buildsystem=golang --with=golang

## ubuntu-push 0.68+16.04.20160310.2

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,8 @@
 GODEPS += code.google.com/p/gosqlite/sqlite3
 GODEPS += code.google.com/p/go-uuid/uuid
 
-GOTEST := ./scripts/goctest
+# cgocheck=0 is a workaround for lp:1555198
+GOTEST := GODEBUG=cgocheck=0 ./scripts/goctest
 
 TOTEST = $(shell env GOPATH=$(GOPATH) go list $(PROJECT)/...|grep -v acceptance|grep -v http13client )
 TOBUILD = $(shell grep -lr '^package main')

=== docs/example-client/Makefile ===
# More information: https://wiki.ubuntu.com/Touch/Testing
#
# Notes for autopilot tests:
# -----------------------------------------------------------
# In order to run autopilot tests:
# sudo apt-add-repository ppa:autopilot/ppa
# sudo apt-get update
# sudo apt-get install python-autopilot autopilot-qt
#############################################################

all:

autopilot:
	chmod +x tests/autopilot/run
	tests/autopilot/run

check:
	qmltestrunner -input tests/unit

run:
	/usr/bin/qmlscene $@ push-example.qml

=== debian/control ===
--- 
+++ 
@@ -62,10 +62,9 @@
  The Ubuntu Push Notifications dev & testing server.
 
 Package: ubuntu-push-autopilot
-Architecture: any
+Architecture: amd64 armhf i386
 Multi-Arch: foreign
 Depends: unity8-autopilot,
-         unity-scope-click,
          ubuntu-push-client,
 Recommends: ubuntu-push-dev-server,
 Built-Using: ${misc:Built-Using}

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-ifneq (,$(filter $(DEB_HOST_ARCH), arm64 powerpc ppc64el))
+ifneq (,$(filter $(DEB_HOST_ARCH), arm64 powerpc ppc64el s390x))
   pkg_configs = ubuntuoneauth-2.0 libaccounts-glib click-0.4 ubuntu-app-launch-2 url-dispatcher-1 messaging-menu dbus-1 libnih libnih-dbus glib-2.0 gobject-2.0
   export CGO_CFLAGS := \
     $(shell $(foreach pkg, $(pkg_configs), pkg-config --cflags $(pkg); ))
@@ -25,6 +25,9 @@
 	dh_auto_build --buildsystem=golang
 	(cd signing-helper && cmake . && make)
 
+override_dh_auto_test:
+	GODEBUG=cgocheck=0 dh_auto_test -O--buildsystem=golang
+
 override_dh_install:
 	dh_install -Xusr/bin/cmd --fail-missing

## ubuntu-push 0.68+16.04.20160503.4

=== debian/changelog ===
ubuntu-push (0.68+16.04.20160503.4-0ubuntu1) xenial; urgency=medium

  [ Jonas G. Drange, Simon Fels, Timo Jyrinki, jonas-drange ]
  * Correctly refer to NMState as “State”, not “state”, as the move from
    gdbus-lib to gdbus requires it. (LP: #1575184, #1517189, #1469398)

 -- Simon Fels <simon.busch@canonical.com>  Tue, 03 May 2016 12:05:11 +0000

## ubuntu-push 0.68+16.10.20160808.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
SET (EXAMPLES_TARGET ubuntuoneauth-examples)

SET (SIGNING_EXE "signing-helper")

find_package (PkgConfig REQUIRED)
pkg_check_modules(UBUNTUONE REQUIRED ubuntuoneauth-2.0)
add_definitions(${UBUNTUONE_CFLAGS} ${UBUNTUONE_CFLAGS_OTHER})


# Qt5 bits
SET (CMAKE_INCLUDE_CURRENT_DIR ON)
SET (CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

SET (SIGNING_SOURCES signing-helper.cpp)
SET (SIGNING_HEADERS signing.h)

add_executable (${SIGNING_EXE}
  ${SIGNING_SOURCES}
  ${SIGNING_HEADERS})
qt5_use_modules (${SIGNING_EXE} DBus Network)

target_link_libraries (${SIGNING_EXE}
  ${UBUNTUONE_LDFLAGS})



add_custom_target(examples-valgrind
    COMMAND "valgrind --tool=memcheck ${CMAKE_CURRENT_BINARY_DIR}/${SIGNING_EXE}"
    DEPENDS ${SIGNING_EXE}
)

add_custom_target(examples-valgrind-leaks
    COMMAND "valgrind --tool=memcheck --track-origins=yes --num-callers=40 --leak-resolution=high --leak-check=full ${CMAKE_CURRENT_BINARY_DIR}/${SIGNING_EXE}"
    DEPENDS ${SIGNING_EXE}
)

INSTALL_TARGETS( "lib/ubuntu-push-client/" ${SIGNING_EXE})

=== Makefile ===
# help massage and extract from go development 1.3 net/http the client bits

grab:
	cp $(GOCHECKOUT)/src/pkg/net/http/*.go .
	cp $(GOCHECKOUT)/LICENSE .
	mkdir -p httptest
	mkdir -p httputil
	mkdir -p testdata
	cp $(GOCHECKOUT)/src/pkg/net/http/httptest/*.go httptest
	cp $(GOCHECKOUT)/src/pkg/net//http/httputil/*.go httputil
	cp $(GOCHECKOUT)/src/pkg/net/http/testdata/* testdata
	hg -R $(GOCHECKOUT) summary > _using.txt

full-prepare:
	patch -R -p5 < _patches/sync_pool.Rpatch
	patch -p1 < _patches/no_keepalive.patch
	sed -i -e 's+"net/http"+"launchpad.net/ubuntu-push/http13client"+' *.go httptest/*.go httputil/*.go
	sed -i -e 's+"net/http/+"launchpad.net/ubuntu-push/http13client/+' *.go httptest/*.go httputil/*.go
	patch -p1 < _patches/no_serve_test_unsupported_bench.patch

prune:
	rm -rf example_test.go filetransport*.go fs*.go race.go range_test.go \
	sniff*.go httptest httputil testdata triv.go jar.go status.go \
	cookie_test.go
	sed -i -e 's+"launchpad.net/ubuntu-push/http13client/+"net/http/+' *.go

fix:
	patch -p1 < _patches/empty_server.patch
	patch -p1 < _patches/fix_tests.patch
	patch -p1 < _patches/fix_code.patch
	patch -p1 < _patches/fix_status.patch
	patch -p1 < _patches/tweak_doc_go.patch
	go fmt

wipe:
	rm -rf *.go httptest httputil testdata

.PHONY: grab full-prepare prune fix wipe

=== debian/changelog ===
ubuntu-push (0.68+16.10.20160808.1-0ubuntu1) yakkety; urgency=medium

  * No change rebuild for UAL ABI change

 -- Ted Gould <ted@gould.cx>  Mon, 08 Aug 2016 21:50:48 +0000

ubuntu-push (0.68+16.10.20160718.4-0ubuntu1) yakkety; urgency=medium

  [ Arthur Mello ]
  * Update ubuntu-push to work wih the new Notification panel
  * Add ignore files to docs/example-server
  * Mark helper as done only once we have sent the output so to order
    things

  [ jonas-drange ]
  * disable logger tests that expect log.Lshortfile on ppc/arm 64
  * remove unused sess variable

 -- Jonas G. Drange <jonas.drange@canonical.com>  Mon, 18 Jul 2016 13:28:13 +0000

## ubuntu-push 0.68+16.10.20161003

=== Makefile ===
GOPATH := $(shell cd ../../..; pwd)
export GOPATH

PROJECT = launchpad.net/ubuntu-push

ifneq ($(CURDIR),$(GOPATH)/src/launchpad.net/ubuntu-push)
$(error unexpected curdir and/or layout)
endif

GODEPS = launchpad.net/gocheck
GODEPS += launchpad.net/go-dbus/v1
GODEPS += launchpad.net/go-xdg/v0
GODEPS += github.com/mattn/go-sqlite3
GODEPS += github.com/pborman/uuid

# cgocheck=0 is a workaround for lp:1555198
GOTEST := GODEBUG=cgocheck=0 ./scripts/goctest

TOTEST = $(shell env GOPATH=$(GOPATH) go list $(PROJECT)/...|grep -v acceptance|grep -v http13client )
TOBUILD = $(shell grep -lr '^package main')

all: fetchdeps bootstrap build-client build-server-dev

fetchdeps: .has-fetched-deps

.has-fetched-deps: PACKAGE_DEPS
	@$(MAKE) --no-print-directory refetchdeps
	@touch $@

refetchdeps:
	sudo apt-get install $$( grep -v '^#' PACKAGE_DEPS )

bootstrap: dependencies.tsv
	$(RM) -r $(GOPATH)/pkg
	mkdir -p $(GOPATH)/bin
	mkdir -p $(GOPATH)/pkg
	go get -u launchpad.net/godeps
	go get -d -u $(GODEPS)
	$(GOPATH)/bin/godeps -u dependencies.tsv
	go install $(GODEPS)

dependencies.tsv:
	$(GOPATH)/bin/godeps -t $(TOTEST) $(foreach i,$(TOBUILD),$(dir $(PROJECT)/$(i))) 2>/dev/null | cat > $@

check:
	$(GOTEST) $(TESTFLAGS) $(TOTEST)

check-race:
	$(GOTEST) $(TESTFLAGS) -race $(TOTEST)

acceptance:
	cd server/acceptance; ./acceptance.sh

build-client: ubuntu-push-client signing-helper/signing-helper

%.deps: %
	$(SH) scripts/deps.sh $<

%: %.go
	go build -o $@ $<

include $(TOBUILD:.go=.go.deps)

signing-helper/Makefile: signing-helper/CMakeLists.txt signing-helper/signing-helper.cpp signing-helper/signing.h
	cd signing-helper && (make clean || true) && cmake .

signing-helper/signing-helper: signing-helper/Makefile signing-helper/signing-helper.cpp signing-helper/signing.h
	cd signing-helper && make

build-server-dev: push-server-dev

run-server-dev: push-server-dev
	./$< sampleconfigs/dev.json

push-server-dev: server/dev/server
	mv $< $@

# very basic cleanup stuff; needs more work
clean:
	$(RM) -r coverhtml
	$(MAKE) -C signing-helper clean || true
	$(RM) push-server-dev
	$(RM) $(TOBUILD:.go=)

distclean:
	bzr clean-tree --verbose --ignored --force

coverage-summary:
	$(GOTEST) $(TESTFLAGS) -a -cover $(TOTEST)

coverage-html:
	mkdir -p coverhtml
	for pkg in $(TOTEST); do \
		relname="$${pkg#$(PROJECT)/}" ; \
		mkdir -p coverhtml/$$(dirname $${relname}) ; \
		$(GOTEST) $(TESTFLAGS) -a -coverprofile=coverhtml/$${relname}.out $$pkg ; \
		if [ -f coverhtml/$${relname}.out ] ; then \
	           go tool cover -html=coverhtml/$${relname}.out -o coverhtml/$${relname}.html ; \
	           go tool cover -func=coverhtml/$${relname}.out -o coverhtml/$${relname}.txt ; \
		fi \
	done

format:
	go fmt $(PROJECT)/...

check-format:
	scripts/check_fmt $(PROJECT)

protocol-diagrams: protocol/state-diag-client.svg protocol/state-diag-session.svg
%.svg: %.gv
	# requires graphviz installed
	dot -Tsvg $< > $@

.PHONY: bootstrap check check-race format check-format \
	acceptance build-client build-server-dev run-server-dev \
	coverage-summary coverage-html protocol-diagrams \
	fetchdeps refetchdeps clean distclean all

.INTERMEDIATE: server/dev/server

=== debian/changelog ===
ubuntu-push (0.68+16.10.20161003-0ubuntu1) yakkety; urgency=medium

  * Drops dead dependencies, replaces them with newer ones.

 -- Jonas G. Drange <jonas.drange@canonical.com>  Mon, 03 Oct 2016 11:10:45 +0000

ubuntu-push (0.68+16.10.20160825.4-0ubuntu1) yakkety; urgency=medium

  [ Arthur Mello ]
  * Fix check for empty package name when receiving notifications from
    legacy deb apps (LP: #1611848)

 -- Arthur Renato Mello <arthur.mello@canonical.com>  Thu, 25 Aug 2016 21:43:59 +0000

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,8 @@
                golang-go-dbus-dev,
                golang-go-xdg-dev,
                golang-gocheck-dev,
-               golang-gosqlite-dev,
-               golang-uuid-dev,
+               golang-github-mattn-go-sqlite3-dev,
+               golang-github-pborman-uuid-dev,
                libgcrypt11-dev,
                libglib2.0-dev (>= 2.31.6),
                libmessaging-menu-dev,
@@ -24,6 +24,7 @@
                libaccounts-glib-dev,
                cmake,
                python3,
+               upstart,
 Standards-Version: 3.9.5
 Homepage: http://launchpad.net/ubuntu-push
 Vcs-Bzr: lp:ubuntu-push

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,8 @@
 export UBUNTU_PUSH_TEST_RESOURCES_ROOT := $(CURDIR)
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
+# Skip tests on the archs they are known to be flaky with current configuration
+testskip_architectures := powerpc s390x
 
 ifneq (,$(filter $(DEB_HOST_ARCH), arm64 powerpc ppc64el s390x))
   pkg_configs = ubuntuoneauth-2.0 libaccounts-glib click-0.4 ubuntu-app-launch-2 url-dispatcher-1 messaging-menu dbus-1 libnih libnih-dbus glib-2.0 gobject-2.0
@@ -26,7 +28,10 @@
 	(cd signing-helper && cmake . && make)
 
 override_dh_auto_test:
-	GODEBUG=cgocheck=0 dh_auto_test -O--buildsystem=golang
+ifneq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(testskip_architectures)))
+	cd $$( find ./ -type d -regex '\./[^/]*/src/launchpad.net' -printf "%h\n" | head -n1) && \
+	env GODEBUG=cgocheck=0 GOPATH=$$(cd ..; pwd) go test -v $$(env GOPATH=$$(cd ..; pwd) go list $(DH_GOPKG)/... | grep -v acceptance | grep -v http13client )
+endif
 
 override_dh_install:
 	dh_install -Xusr/bin/cmd --fail-missing
